import { trim } from "lodash";
import say from "say";
import path from "path";
import fs from "fs";
const audioconcat = require("wav-concat");

const voices = new Map([
  ["win32_cn", "Sin-ji"],
  ["win32_en", "Samantha"],
  ["darwin_cn", "Sin-ji"],
  ["darwin_en", "Samantha"]
]);

export function voiceSelector(lang:string) {
  return voices.get(`${process.platform}_${lang}`);
}

export const exportWav = (lang:string, outputPath:string, text?:string) => new Promise((resolve, reject) => {
  if (text) {
    if (lang !== "pt") {
      say.export(text, voiceSelector(lang), 1, outputPath, () => resolve(true));
    } else {
      const segments = text.split(",").map(x => trim(x))
      .map(segment => path.join("./ptSegments", `${segment.toLowerCase()}.wav`))
      .filter(x => fs.existsSync(x));

      console.log(segments);
      if (segments.length > 0) {
        audioconcat(segments).concat(outputPath).on("end", () => resolve(true));
      } else {
        resolve(false);
      }
    }
  } else {
    resolve(false);
  }
});